package Auxiliar;

public class ValoresSensores {
	
	/**
	 * constantes de conhecimento global correspondentes ao index dos sensores 
	 */
	public final static int frente = 0;
	public final static int chaoEsquerda = 5;
	public final static int chaoDireita = 3;
	public final static int frenteEsquerda = 7;
	public final static int frenteDireita = 1;
	public final static int direita = 2;
	public final static int esquerda = 6;
	public final static int tras = 4;
	
	/**
	 * variaveis para os valor dos sensores do cho
	 */
	private int myEsquerda;
	private int myDireita;
	
	/**
	 * Metodo Construtor
	 * @param esq valor inteiro correspondente ao sensor 5
	 * @param dir valor inteiro correspondente ao sensor 3
	 */
	public ValoresSensores(int esq, int dir) {
		this.myEsquerda = esq;
		this.myDireita = dir;
	}
	
	/**
	 * Metodo diferena absoluta entre os valores do cho
	 * @return int valor da diferena entre sensores
	 */
	public int getDiferencaAbsoluta() {
		return Math.abs(myEsquerda - myDireita);
	}

	/**
	 * Metodo que devolve o valor no sensor correspondente ao cho esquerda
	 * @return int valor do sensor da esquerda
	 */
	public int getEsquerda() {
		return myEsquerda;
	}
	
	/**
	 * Metodo que devolve o valor no sensor correspondente ao cho direita
	 * @return int valor do sensor da direita
	 */
	public int getDireita() {
		return myDireita;
	}
	
	/**
	 * Metodo que devolve os valores dos sensores  esquerda e direita
	 * @return String representao dos valores
	 */
	public String toString() {
		return "Esquerda = " + myEsquerda + " ; Direita = " + myDireita + " ;\n";
	}
}
