package Robot;

import Tarefa.TarefaRobot;
import hemissonComm.HemissonRobot;

public class RobotHemissonActivo extends HemissonRobot {
	
	private TarefaRobot tarefa;
		
	public RobotHemissonActivo(String myPort, String myId) {
		super(myPort, myId);
		this.tarefa = null;
	}
	
	public void executaTarefa(TarefaRobot task) {
		if(this.tarefa != null) 
			tarefa.interrupt();
		tarefa = task;
		try {
			if(this.tarefa != null)
				tarefa.start();
		} catch (Exception e) {
			System.err.println("Erro ao executar a tarefa");
			e.printStackTrace();
		}
	}
	
	public TarefaRobot getTarefa() {
		return tarefa;
	}

	public void terminarTarefa() throws Exception {
		if(tarefa == null) throw new Exception("Este robot no possui qualquer tarefa atribuda");
		try {
			tarefa.interrupt();
			Thread.sleep(500);
			this.setSpeed(0,0);
		} catch (Exception e) {
			throw new Exception ("Ocorreu um erro ao tentar terminar esta tarefa.",e);
		}
	}
}
