package Tarefa;

import Avaliador.AvaliadorAmbiente;
import hemissonComm.HemissonRobot;

public class SegueLinha extends TarefaRobot{
	private AvaliadorAmbiente aval;
	private boolean lastEsq;
	private boolean lastDir;
	private boolean esq;
	private boolean dir;
	
	public SegueLinha(HemissonRobot robot, AvaliadorAmbiente aval) {
		super(robot,aval);
		this.aval = aval;
		this.lastEsq = false;
		this.lastDir = false;
	}
	
	public void runOnce (){
		robot.beeper(1);
		valoresSensores = robot.readSonar();
		esq = (valoresSensores[esquerda] < aval.getLimiarEsquerda());
		dir = (valoresSensores[direita] < aval.getLimiarDireita());
			
		if(dir && esq) {
			robot.setSpeed(2,2);
		} else if(dir && !esq) {
			robot.setSpeed(2,-1);
		} else if(!dir && esq) {
			robot.setSpeed(-1,2);
		} else if(!dir && !esq) {
			if(lastDir && !lastEsq) {
				robot.setSpeed(3,-3);
			} else if (!lastDir && lastEsq) {
				robot.setSpeed(-3,3);
			} else if (lastDir && lastEsq) {
				robot.setSpeed(-3,-3);
			} else {
				robot.setSpeed(rand.nextInt(5),rand.nextInt(5));
				System.err.println("Warning: Estou a vagear");
			}
		}
		lastEsq = esq;
		lastDir = dir;
			
		try {
			sleep(500);
		} catch (InterruptedException e) {
			robot.setSpeed(0,0);
			robot.beeper(3);
			e.printStackTrace();
			return;
		}
		robot.setSpeed(0,0);
	}
}
