package Tarefa;

import hemissonComm.HemissonRobot;
import java.util.Random;
import Avaliador.Avaliador;

public abstract class TarefaRobot extends Thread {

	/**
	 * variaveis correspondentes aos index dos sensores para o cho
	 */
	public static final int esquerda = 5;
	public static final int direita = 3;
	
	/**
	 * variavel correspondete ao HemissonRobot corrente
	 */
	protected HemissonRobot robot;
	
	/**
	 * variavel para o avaliador do ambiente
	 */
	protected Avaliador aval;
	
	/**
	 * variavel Random
	 */
	protected Random rand;
	
	/**
	 * variavel para guardar os valores lidos dos sensores
	 */
	protected int[] valoresSensores;
	
	/**
	 * 
	 */
	private boolean execute;
	
	/**
	 * Metodo Contrutor
	 * @param robot HemissonRobot correspondente ao robot corrente
	 * @param aval correspondente ao avaliador do ambiente corrente
	 */
	public TarefaRobot(HemissonRobot robot, Avaliador aval) {
		super();
		this.robot = robot;
		this.aval = aval;
		this.rand = new Random();
		this.valoresSensores = null;
		this.execute = true;
	}
	
	/**
	 * Metodo que representa um turno de execuo
	 * @throws Exception
	 */
	public abstract void runOnce() throws Exception;
	
	/**
	 * Metodo Run da classe
	 */
	public void run() {
		try {
			while(this.toExecute()) {
				runOnce();
			}
		} catch (Exception e) {
			System.err.println("Ocorreu uma excepo: " + e.getMessage());
			this.execute = false;
		}
	}	
	
	/**
	 * Metodo que verifica se a tarefa est em execuo
	 * @return boolean execute?
	 */
	public boolean toExecute() {
		return execute;
	}
	
	/**
	 * Metodo que interrompe a execuo de uma tarefa
	 */
	public void interrupt() {
		this.execute = false;
	}
	
	/**
	 * Metodo que faz o start  tarefa
	 */
	public final void start() {
		super.start();
	}
	
}
