package VA;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import Tarefa.SegueLinha;

import Avaliador.AvaliadorAmbiente;

import hemissonComm.HemissonRobot;

public class VAMain {
	public static void main (String[] args) throws InterruptedException{
		System.out.println("INIT");
		
		HemissonRobot[] listaDeRobot = avaliaArgumentos(args);
		AvaliadorAmbiente[] avaliadores = new AvaliadorAmbiente[listaDeRobot.length];
		for(int i= 0; i<listaDeRobot.length; i++) {
			avaliadores[i] = new AvaliadorAmbiente(listaDeRobot[i]);
			avaliadores[i].init();
			avaliadores[i].calcularLimiar();
		}
		Thread listaDeTarefas[] = new Thread[listaDeRobot.length];
		for(int i = 0; i<listaDeRobot.length; i++)
			listaDeTarefas[i] = new SegueLinha(listaDeRobot[i],avaliadores[i]);
		
		BufferedReader teclado = new BufferedReader (new InputStreamReader(System.in));
		System.out.println("Enter para iniciar main");
		try {
			teclado.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return;
		}
		
		for(int i = 0; i<listaDeRobot.length; i++)
			listaDeTarefas[i].start();
	}

	private static HemissonRobot[] avaliaArgumentos(String[] args) {
		int n_robot = args.length / 2;
		HemissonRobot[] resposta = new HemissonRobot[n_robot];
		for(int i = 0; i<n_robot; i++)
			resposta[i] = new HemissonRobot(args[i*2],args[(i*2)+1]);
		return resposta;
		
	}
}
