package hemissonComm;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;

import javax.comm.CommPortIdentifier;
import javax.comm.NoSuchPortException;
import javax.comm.PortInUseException;
import javax.comm.SerialPort;
import javax.comm.UnsupportedCommOperationException;

import com.sun.comm.Win32Driver;

public abstract class SerialComm {
	protected BufferedReader sensorReader; //flux de lecture du port
	
	protected OutputStream outputStream; //flux d'criture du port
	
	protected CommPortIdentifier portId; //identifiant du port
	
	protected SerialPort serialPort; //le port srie
	
	/**
	 * Construtor
	 */
	protected SerialComm(String port) {
		//initialisation du driver
		Win32Driver w32Driver = new Win32Driver();
		w32Driver.initialize();
		//rcupration de l'identifiant du port
		try {
			portId = CommPortIdentifier.getPortIdentifier(port);
		} catch (NoSuchPortException e) {
			System.err.println("Problem get Port ID");
		}
		//ouverture du port
		try {
			serialPort = (SerialPort) portId.open("HemissonCom", 30000);
		} catch (PortInUseException e) {
			System.err.println("Problem HemissonCom Open");
		}
		//rgle les paramtres de la connexion
		try {
			serialPort.setSerialPortParams(115200, SerialPort.DATABITS_8,
					SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
		} catch (UnsupportedCommOperationException e) {
			System.err.println("Problem HemissonCom Set Parameter Port");
		}
		//rcupration du flux de lecture et criture du port
		try {
			outputStream = serialPort.getOutputStream();
			sensorReader = new BufferedReader(new InputStreamReader(serialPort
					.getInputStream()));
		} catch (IOException e) {
		}
	}
	
	/**
	 * Comunicao com os Hemisson.
	 */
	protected BufferedReader sendCommand(String filename) {
		char[] command;
		try {
			command = filename.toCharArray();
			
			outputStream.write((int) '\r');
			Thread.sleep(100);
			
			Thread.sleep(100);
			//outputStream.write((int)envoie);
			for (int i = 0; i < command.length; i++) {
				outputStream.write((int) command[i]);
				Thread.sleep(100);
			}
			outputStream.write((int) '\r');
			Thread.sleep(100);
			
		} catch (Exception e) {
		}
		return sensorReader;
	}
	
	/**
	 * Fecho de todos os ports e streams abertos
	 */
	public void close() {
		try {
			sensorReader.close();
			outputStream.close();
		} catch (IOException e) {
		}
		serialPort.close();
	}
	
	
}
